#include "os.h"

#ifndef CONFIGDIR
#define CONFIGDIR "."
#endif

#ifdef HAVE_SYSLOG_H
#define LOG_FACILITY LOG_LOCAL7
#else
#define LOG_FACILITY 0
#endif

#define INDEXER_USER_AGENT "UdmSearch"
#define MAXDOCSIZE	1024*1024  /* 1Mb */
#define MAXWORDSIZE	32
#define MAXURLSIZE	127

/* Max URLs in cache */
#define MAXHSIZE	1023

#define STRSIZ			1024*2
#define free_it(x)		{if(x){free(x);x=NULL;}}
#define STRNCMP(x,y)		(strncmp(x,y,strlen(y)))
#define STRNCASECMP(x,y)	(strncasecmp(x,y,strlen(y)))
#define SKIP(s,set)		while((*s)&&(strchr(set,*s)))s++;
#define SKIPN(s,set)		while((*s)&&(!strchr(set,*s)))s++;
#define STREND(s)		(s+strlen(s))
#define STRNCPY(x,y)		{strncpy(x,y,sizeof(x));x[sizeof(x)-1]=0;}

#define ORD_RATE	1
#define ORD_DATE	2

#define MOD_ALL		1
#define MOD_ANY		2

#define CRITICAL_TOTAL	0
#define CRITICAL_ROBOTS	1

#define IND_UNKNOWN		0
#define IND_OK			1
#define IND_ERROR		2
#define IND_NO_TARGET		3
#define IND_TERMINATED		4

#define FLAG_REINDEX    1
#define FLAG_EXP_FIRST  2
#define FLAG_ADD_SERV	4
#define FLAG_MARK	8
#define FLAG_SPELL	16

typedef struct word_struct {
	int count;
	int code;
	char *word;
} UDM_WORD;

typedef struct href_struct {
	char *href;
	int referrer;
	int hops;
	int stored;
} HREF;

typedef struct robots_struct {
	char *hostinfo;
	char *path;
} ROBOT;

typedef struct stat_struct {
	int status;
	int expired;
	int total;
} STAT;

typedef struct server_struct {
	char *url;
	char *charset;
	char *proxy;
	char *basic_auth;
	char *htdb_list;
	char *htdb_doc;
	int  proxy_port;
	int  period;
	int  hint;
	int  net_errors;
	int  max_net_errors;
	int  read_timeout;
	int  outside;
	int  maxhops;
	int  gindex;
	int  gfollow;
	int  deletebad;
	int  userobots;
	int  bodyweight;
	int  titleweight;
	int  urlweight;
	int  descweight;
	int  keywordweight;
} SERVER;


typedef struct url_struct {
	int	url_id;
	int	status;
	int	size;
	int	rating;
	int	referrer;
	int	tag;
	int	hops;
	char	*url;
	char	*content_type;
	char	*last_modified;
	char	*title;
	char 	*text;
	char	*last_index_time;
	char	*next_index_time;
	char	*keywords;
	char	*description;
	char	*crc;
} DOCUMENT;


typedef struct indexer_struct{
	int handle;
	int mwords;
	int nwords;
	int DBError;
	int action;
	char state[128];
	UDM_WORD *Word;
	char *buf;
	char *charset;
	void * db;
} INDEXER;

extern char * gettoken(char *s, const char *delim, char **last);
extern char * trim_chars(char *p, char * delim);
